@0xc0542f62613a5c5e;

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema"); 

using OID = import "utils.capnp".OID;

interface TraitSuper {
    getName @0 () -> ( name :Text );
}

struct TraitError(ConstraintError) {
    union {
        permissionFailed @0 :Void;
        constraintViolation @1 :ConstraintError;
    }
}

interface Hint {
    getOid @0 () -> ( oid :OID );
    getAbstract @1 () -> ( abstract :List(Hint) );
    # Sorted least to most abstract. abstract[0] is the next less specific Hint.
}
